# Method: projects.locations.memberships.generateExclusivityManifest

- [HTTP request](https://docs.cloud.google.com/kubernetes-engine/fleet-management/docs/reference/rest/v1alpha/projects.locations.memberships/generateExclusivityManifest#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/kubernetes-engine/fleet-management/docs/reference/rest/v1alpha/projects.locations.memberships/generateExclusivityManifest#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/kubernetes-engine/fleet-management/docs/reference/rest/v1alpha/projects.locations.memberships/generateExclusivityManifest#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/kubernetes-engine/fleet-management/docs/reference/rest/v1alpha/projects.locations.memberships/generateExclusivityManifest#body.request_body)
- [Response body](https://docs.cloud.google.com/kubernetes-engine/fleet-management/docs/reference/rest/v1alpha/projects.locations.memberships/generateExclusivityManifest#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/kubernetes-engine/fleet-management/docs/reference/rest/v1alpha/projects.locations.memberships/generateExclusivityManifest#body.GenerateExclusivityManifestResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/kubernetes-engine/fleet-management/docs/reference/rest/v1alpha/projects.locations.memberships/generateExclusivityManifest#body.aspect)
- [Examples](https://docs.cloud.google.com/kubernetes-engine/fleet-management/docs/reference/rest/v1alpha/projects.locations.memberships/generateExclusivityManifest#examples)
- [Try it!](https://docs.cloud.google.com/kubernetes-engine/fleet-management/docs/reference/rest/v1alpha/projects.locations.memberships/generateExclusivityManifest#try-it)

memberships.generateExclusivityManifest generates the manifests to update the exclusivity artifacts in the cluster if needed.

Exclusivity artifacts include the Membership custom resource definition (CRD) and the singleton Membership custom resource (CR). Combined with memberships.validateExclusivity, exclusivity artifacts guarantee that a Kubernetes cluster is only registered to a single GKE Hub.

The Membership CRD is versioned, and may require conversion when the GKE Hub API server begins serving a newer version of the CRD and corresponding CR. The response will be the converted CRD and CR if there are any differences between the versions.

### HTTP request

`GET https://gkehub.googleapis.com/v1alpha/{name=projects/*/locations/*/memberships/*}:generateExclusivityManifest`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The Membership resource name in the format `projects/*/locations/*/memberships/*`. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `name`: - `gkehub.memberships.generateConnectManifest` |

### Query parameters

| Parameters ||
|---|---|
| `crdManifest` | `string` Optional. The YAML manifest of the membership CRD retrieved by `kubectl get customresourcedefinitions membership`. Leave empty if the resource does not exist. |
| `crManifest` | `string` Optional. The YAML manifest of the membership CR retrieved by `kubectl get memberships membership`. Leave empty if the resource does not exist. |

### Request body

The request body must be empty.

### Response body

The response of the exclusivity artifacts manifests for the client to apply.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "crdManifest": string, "crManifest": string } ``` |

| Fields ||
|---|---|
| `crdManifest` | `string` The YAML manifest of the membership CRD to apply if a newer version of the CRD is available. Empty if no update needs to be applied. |
| `crManifest` | `string` The YAML manifest of the membership CR to apply if a new version of the CR is available. Empty if no update needs to be applied. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).